unit unMain;

interface

uses
  Windows, SysUtils, Classes,  Controls, Forms, Dialogs,
  Buttons, StdCtrls, Spin, ComCtrls, ExtCtrls, MP3RemoteI;

type
  TForm1 = class(TForm)
    Status: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    RadioG: TRadioGroup;
    se1: TSpinEdit;
    se2: TSpinEdit;
    Label4: TLabel;
    Label5: TLabel;
    cb1: TCheckBox;
    Edit1: TEdit;
    Label6: TLabel;
    EQ: TTabSheet;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    TabSheet4: TTabSheet;
    Edit2: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Button7: TButton;
    Button8: TButton;
    Edit3: TEdit;
    Button9: TButton;
    Label14: TLabel;
    Button10: TButton;
    SpinEdit1: TSpinEdit;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Label16: TLabel;
    Label17: TLabel;
    Button15: TButton;
    Label15: TLabel;
    od: TOpenDialog;
    TabSheet5: TTabSheet;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    Label3: TLabel;
    SpeedButton7: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Label7: TLabel;
    Label13: TLabel;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    Button1: TButton;
    ProgressBar1: TProgressBar;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    lAlt: TLabel;
    lCtrl: TLabel;
    lShift: TLabel;
    Timer1: TTimer;
    Memo1: TMemo;
    Button11: TButton;
    TabSheet6: TTabSheet;
    RadioGroup1: TRadioGroup;
    CountDown: TCheckBox;
    Button16: TButton;
    Label18: TLabel;
    Button17: TButton;
    Button18: TButton;
    SpeedButton10: TSpeedButton;
    TabSheet7: TTabSheet;
    Label19: TLabel;
    SpinEdit2: TSpinEdit;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    TabSheet8: TTabSheet;
    Memo2: TMemo;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    GroupBox2: TGroupBox;
    Label31: TLabel;
    Label32: TLabel;
    eqOn: TCheckBox;
    eqAuto: TCheckBox;
    eq10: TScrollBar;
    eq0: TScrollBar;
    eq1: TScrollBar;
    eq2: TScrollBar;
    eq3: TScrollBar;
    eq7: TScrollBar;
    eq4: TScrollBar;
    eq5: TScrollBar;
    eq6: TScrollBar;
    eq8: TScrollBar;
    eq9: TScrollBar;
    brate: TLabel;
    srate: TLabel;
    stereo: TLabel;
    Label30: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ProgressBar1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure cb1Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure se1Change(Sender: TObject);
    procedure RadioGClick(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure ProgressBar1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ProgressBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button11Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure remoteAmpFound(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure eq10Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure eqOnClick(Sender: TObject);
    procedure eqAutoClick(Sender: TObject);
  private
    { Private declarations }
     Scrolling   : Boolean;
     aOutPutType : TOutPutType;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses unAbout;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
    aOutPutType:=osh_M_S_ms;

    
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
Var
 KeyType : TKeyType;
begin

 IF ShiftDown then KeyType:=ktShift else
   If CtrlDown then KeyType:=ktCtrl else
     KeyType:=ktNone;
 IF Sender is TSpeedButton then
   // Simulates pressing one of the 5 main buttons on winamp
   PressButton(TSpeedButton(Sender).Tag,KeyType);

end;

procedure TForm1.Timer1Timer(Sender: TObject);

procedure UpDateWinInfo;
Var
 P : tpoint;
 s : PChar;

Begin

 GetAmpPos(p.x,p.y);
 se1.value:=p.x;
 se2.value:=p.y;

 // This had to be done like this for compatibility with VB
 GetMem(S,256);
  GetAmpCaption(s,255);
  edit1.Text:=String(S);
 FreeMem(S,256);


 cb1.Checked:=GetOnTop;

 case GetAmpWindowState of
  wsNormal    : RadioG.itemindex:=0;
  wsMinimized,wsMaximized : RadioG.itemindex:=1;
 end;

end;

Procedure UpdateAmp2;
Begin
 Label30.Caption:='Current Position: '+IntToStr(GetPlayListPos);
 Label20.Caption:='Playlist contains '+IntToStr(GetListLength)+' tracks';
End;

Procedure UpdateEQ;
Begin
  eqOn.Checked:=GetEQOn;
  eqAuto.Checked:=GetEQAutoLoad;

  eq10.Position:=GetEQ(10);  //Pre-Amp

  eq0.Position:=GetEQ(0);
  eq1.Position:=GetEQ(1);
  eq2.Position:=GetEQ(2);
  eq3.Position:=GetEQ(3);
  eq4.Position:=GetEQ(4);
  eq5.Position:=GetEQ(5);
  eq6.Position:=GetEQ(6);
  eq7.Position:=GetEQ(7);
  eq8.Position:=GetEQ(8);
  eq9.Position:=GetEQ(9);
End;

Var
 SongP  : Integer;
 S      : PChar;
begin
 IF GetStereo then
  Stereo.Caption:='Stereo'
 else Stereo.Caption:='Mono';
 brate.Caption:=IntToStr(GetBitRate)+' kbs';
 srate.Caption:=IntToStr(GetSampleRate)+' Khz';
 
 SongP:=GetSongPos;                 // Song position in millisecs
 progressbar1.Min:=0;
 progressbar1.Max:=ABS(GetSongLength);   // Song length in secs
 IF not Scrolling then
   progressbar1.position:=ABS(SongP div 1000); // Need to convert to secs

 IF CountDown.Checked then
  Begin
   //Count backward
   SongP:=Abs((GetSongLength*1000)-SongP)*-1;

   // This had to be done like this for compatibility with VB
   GetMem(S,256);
    IntToTimeStr(SongP,aOutPutType,s,255);
    label2.caption:=s;   //Convert millisec to Str
   FreeMem(S,256);

  end
 else
  Begin
   // This had to be done like this for compatibility with VB
   GetMem(S,256);
    IntToTimeStr(SongP,aOutPutType,s,255);
    label2.caption:=s;   //Convert millisec to Str
   FreeMem(S,256);
  end;

 Case GetAmpstate of
  asPlay  : label1.caption:='Playing';
  asPause : label1.Caption:='Paused';
  asStop  : label1.caption:='Stopped';
  asError : label1.caption:='Error?';
 end;

 Label1.Caption:=Label1.Caption+' song of '+IntToStr(progressbar1.Max)+' secs';

 IF PageControl1.ActivePage=tabsheet1 then UpDateWinInfo;
 IF PageControl1.ActivePage=tabsheet7 then UpdateAmp2;
 IF PageControl1.ActivePage=EQ then UpdateEQ;

 if ShiftDown then
  lShift.caption:='Down'
 else lShift.caption:='Up';
 if AltDown then
  lAlt.caption:='Down'
 else lAlt.caption:='Up';
 if CtrlDown then
  lCtrl.caption:='Down'
 else lCtrl.caption:='Up';

end;

procedure TForm1.Button1Click(Sender: TObject);
Var
 S : PChar;
begin
 IF (Not AmpFound) or (Not GetIsWinamp) then
  Begin
   FindWinamp;
   IF AmpFound then Status.Caption:=' Winamp window found!'
    else IF MessageDlg('Winamp not found: Load it for you?',mtWarning,[mbYes,mbNo],0) = mrYes then
     Begin
       Status.Caption:=' Winamp  loading: Please wait';
       Status.Invalidate;
       IF StartWinampAndWait then
        Begin
         IF AmpFound then Status.Caption:=' Winamp window found!';
        end
       else Status.Caption:= ' Winamp not in registry? Is it installed on your computer?';
     end;
  end;

  // This had to be done like this for compatibility with VB
   GetMem(S,256);
    ConvVersion(GetVersion,s,255);
    Label3.Caption:='Winamp Version: '+s;
   FreeMem(S,256);

  cb1.Checked:=GetOnTop;
end;

procedure TForm1.ProgressBar1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 SetSongpos(round((GetSongLength/progressbar1.Width)*x)*1000);
 scrolling:=false;
end;


procedure TForm1.cb1Click(Sender: TObject);
begin
 SetOnTop(cb1.Checked);
end;



procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
 Volume(True);
end;

procedure TForm1.SpeedButton7Click(Sender: TObject);
begin
 Volume(False);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 SetAmpCaption(Edit1.Text);
end;

procedure TForm1.se1Change(Sender: TObject);
Var
 P : TPoint;
begin

 try
  p.x:=se1.value;
  p.y:=se2.value;
 except
  p.x:=0;
  p.y:=0;
 end;
 SetAmpPos(P.x,p.y);

end;

procedure TForm1.RadioGClick(Sender: TObject);
begin
 case RadioG.itemindex of
  0 : SetAmpWindowState(wsNormal);
  1 : SetAmpWindowState(wsMaximized);
 end;
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
 CountDown.checked:=not CountDown.Checked;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  LoadFileBox;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  PrefBox;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 EQWindow;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  PlayListWindow;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 AboutBox;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
 SendKey(Key);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 CloseWinAmp;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
 StartWinamp;
end;

procedure TForm1.SpeedButton8Click(Sender: TObject);
begin
  FFwd_Rew(False);
end;

procedure TForm1.SpeedButton9Click(Sender: TObject);
begin
 FFwd_Rew(True);
end;


procedure TForm1.Button10Click(Sender: TObject);
begin
 StartPlay;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
 OpenWinampFile(PChar(Edit3.Text));
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
 JumpToTime(spinedit1.value);
end;



procedure TForm1.Button14Click(Sender: TObject);
begin
  WriteList;
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
 DeleteList;
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
 if od.execute then
  begin
   AddFileToListNow(od.filename);
  end;
end;

procedure TForm1.ProgressBar1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 Scrolling:=True;
 progressbar1.Position:=Round((progressbar1.max/progressbar1.Width)*x);
end;

procedure TForm1.ProgressBar1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
 if Scrolling then
 progressbar1.Position:=Round((progressbar1.max/progressbar1.Width)*x);
 
end;


procedure TForm1.Button11Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 case radiogroup1.ItemIndex of
  0:  aOutPutType:=osH_M_S_MS;
  1:  aOutPutType:=osM_S_ms;
  2:  aOutPutType:=osM_S;
  3:  aOutPutType:=osS_Ms;
 end;

end;

procedure TForm1.remoteAmpFound(Sender: TObject);
begin
  ShowMessage('Winamp found! All functions should work now!');
end;

procedure TForm1.Button16Click(Sender: TObject);
begin
 ForcePrevSong;
end;

procedure TForm1.Button18Click(Sender: TObject);
begin
 SendKey('S');
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
 SendKey('R');
end;

procedure TForm1.SpeedButton10Click(Sender: TObject);
begin
 SendKey('L');
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
 SetVolume(ScrollBar1.Position);
 Label27.Caption:=IntToStr(ScrollBar1.Position);
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
 SetPanning(ScrollBar2.Position);
 Label28.Caption:=IntToStr(ScrollBar2.Position);
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
 SetPlayListPos(SpinEdit2.Value);
 Label29.caption:='Song Length: '+IntToStr(GetSongLength)+' secs';
end;

procedure TForm1.Button19Click(Sender: TObject);
begin
 SetPlayListPos(SpinEdit2.Value);
 Play;
end;

procedure TForm1.Button20Click(Sender: TObject);
begin
 foAbout.Show;
end;

procedure TForm1.Button21Click(Sender: TObject);
begin
 AboutDLL;
end;


procedure TForm1.eq10Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
IF Sender is TScrollBar then
    SetEQ(TScrollBar(Sender).Tag,ScrollPos);
end;

procedure TForm1.eqOnClick(Sender: TObject);
begin
 SetEQOn(eqOn.Checked);
end;

procedure TForm1.eqAutoClick(Sender: TObject);
begin
 SetEQAutoLoad(eqAuto.Checked);
end;


end.
